/// <reference types="node" />
import { Config } from "./config";
import { KMS } from "aws-sdk";
import { Readable, Writable } from "stream";
export declare namespace Cipher {
    type Base64String = string;
    type PlainData = string | Buffer;
    type CipherData = Base64String | Buffer;
    class Cipher {
        private config;
        private cipherDataKey;
        private KMS;
        constructor(config: Config, cipherDataKey?: KMS.CiphertextType);
        encrypt(plainData: PlainData): Promise<CipherData>;
        encryptStream(plainData: Readable, outTo: Writable): Promise<void>;
        private encryptDataUseCmkDirectly(plainData);
        private encryptDataUseDataKey(plainData, dataKey);
        private encryptUseCMK(plainData);
        decrypt(cipherData: CipherData): Promise<PlainData>;
        decryptStream(cipherData: Readable, outTo: Writable): Promise<void>;
        private decryptDataUseCmkDirectly(cipherData);
        private decryptDataUseDataKey(cipherData, dataKey);
        private decryptUseCMK(cipherData);
    }
}
