"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var aws_sdk_1 = require("aws-sdk");
var crypto_1 = require("crypto");
var ALG = "aes-256-cbc";
var Cipher;
(function (Cipher_1) {
    var Cipher = (function () {
        function Cipher(config, cipherDataKey) {
            this.config = config;
            this.cipherDataKey = cipherDataKey;
            this.KMS = config.awsOpts ? new aws_sdk_1.KMS(config.awsOpts) : new aws_sdk_1.KMS();
        }
        Cipher.prototype.encrypt = function (plainData) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!this.cipherDataKey) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.encryptDataUseCmkDirectly(plainData)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.encryptDataUseDataKey(plainData, this.cipherDataKey)];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Cipher.prototype.encryptStream = function (plainData, outTo) {
            return __awaiter(this, void 0, void 0, function () {
                var dk, cipher;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.cipherDataKey)
                                throw new Error("cipherDataKey is required!");
                            return [4 /*yield*/, this.decryptUseCMK(this.cipherDataKey)];
                        case 1:
                            dk = _a.sent();
                            cipher = crypto_1.createCipher(ALG, dk);
                            plainData.pipe(cipher).pipe(outTo);
                            return [2 /*return*/];
                    }
                });
            });
        };
        Cipher.prototype.encryptDataUseCmkDirectly = function (plainData) {
            return __awaiter(this, void 0, void 0, function () {
                var cipherData;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.encryptUseCMK(plainData)];
                        case 1:
                            cipherData = _a.sent();
                            if (typeof plainData === "string") {
                                return [2 /*return*/, cipherData.toString("base64")];
                            }
                            else {
                                return [2 /*return*/, cipherData];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        Cipher.prototype.encryptDataUseDataKey = function (plainData, dataKey) {
            return __awaiter(this, void 0, void 0, function () {
                var dk, cipher, str, buff;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.decryptUseCMK(dataKey)];
                        case 1:
                            dk = _a.sent();
                            cipher = crypto_1.createCipher(ALG, dk);
                            if (typeof plainData === "string") {
                                str = cipher.update(plainData, "utf8", "base64");
                                str += cipher.final("base64");
                                return [2 /*return*/, str];
                            }
                            else if (Buffer.isBuffer(plainData)) {
                                buff = cipher.update(plainData);
                                return [2 /*return*/, Buffer.concat([buff, cipher.final()])];
                            }
                            throw new Error("Unknown Type");
                    }
                });
            });
        };
        Cipher.prototype.encryptUseCMK = function (plainData) {
            return __awaiter(this, void 0, void 0, function () {
                var d, r;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            d = Buffer.isBuffer(plainData) ? plainData : new Buffer(plainData, "utf8");
                            return [4 /*yield*/, this.KMS.encrypt({
                                    KeyId: this.config.kmsKeyAlias,
                                    EncryptionContext: this.config.encryptContext,
                                    Plaintext: d
                                }).promise()];
                        case 1:
                            r = _a.sent();
                            return [2 /*return*/, r.CiphertextBlob];
                    }
                });
            });
        };
        Cipher.prototype.decrypt = function (cipherData) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!this.cipherDataKey) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.decryptDataUseCmkDirectly(cipherData)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.decryptDataUseDataKey(cipherData, this.cipherDataKey)];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Cipher.prototype.decryptStream = function (cipherData, outTo) {
            return __awaiter(this, void 0, void 0, function () {
                var dk, decipher;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.cipherDataKey)
                                throw new Error("cipherDataKey is required!");
                            return [4 /*yield*/, this.decryptUseCMK(this.cipherDataKey)];
                        case 1:
                            dk = _a.sent();
                            decipher = crypto_1.createDecipher(ALG, dk);
                            cipherData.pipe(decipher).pipe(outTo);
                            return [2 /*return*/];
                    }
                });
            });
        };
        Cipher.prototype.decryptDataUseCmkDirectly = function (cipherData) {
            return __awaiter(this, void 0, void 0, function () {
                var plainData;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.decryptUseCMK(cipherData)];
                        case 1:
                            plainData = _a.sent();
                            if (typeof cipherData === "string") {
                                return [2 /*return*/, plainData.toString("utf8")];
                            }
                            else {
                                return [2 /*return*/, plainData];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        Cipher.prototype.decryptDataUseDataKey = function (cipherData, dataKey) {
            return __awaiter(this, void 0, void 0, function () {
                var dk, decipher, str, buff;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.decryptUseCMK(dataKey)];
                        case 1:
                            dk = _a.sent();
                            decipher = crypto_1.createDecipher(ALG, dk);
                            if (typeof cipherData === "string") {
                                str = decipher.update(cipherData, "base64", "utf8");
                                str += decipher.final("utf8");
                                return [2 /*return*/, str];
                            }
                            else if (Buffer.isBuffer(cipherData)) {
                                buff = decipher.update(cipherData);
                                return [2 /*return*/, Buffer.concat([buff, decipher.final()])];
                            }
                            throw new Error("Unknown Type");
                    }
                });
            });
        };
        Cipher.prototype.decryptUseCMK = function (cipherData) {
            return __awaiter(this, void 0, void 0, function () {
                var d, r;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            d = Buffer.isBuffer(cipherData) ? cipherData : new Buffer(cipherData, "base64");
                            return [4 /*yield*/, this.KMS.decrypt({
                                    CiphertextBlob: d,
                                    EncryptionContext: this.config.encryptContext
                                }).promise()];
                        case 1:
                            r = _a.sent();
                            return [2 /*return*/, r.Plaintext];
                    }
                });
            });
        };
        return Cipher;
    }());
    Cipher_1.Cipher = Cipher;
})(Cipher = exports.Cipher || (exports.Cipher = {}));
