"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cipher_1 = require("./cipher");
var child_process_1 = require("child_process");
var path = require("path");
var KmsConfig;
(function (KmsConfig) {
    //Wrapper for encrypted string in config file.
    var Encrypted = (function () {
        function Encrypted(value) {
            this.value = value;
        }
        return Encrypted;
    }());
    KmsConfig.Encrypted = Encrypted;
    function encrypted(value) {
        return new Encrypted(value);
    }
    KmsConfig.encrypted = encrypted;
    var DecryptSync = (function () {
        function DecryptSync(conf) {
            this.conf = conf;
        }
        DecryptSync.prototype.decryptSync = function (value) {
            var args = ["kms-vault", "-k", this.conf.kmsKeyAlias];
            if (this.conf.awsOpts && this.conf.awsOpts.region) {
                args.push("-r");
                args.push(this.conf.awsOpts.region);
            }
            args.push("decrypt");
            args.push(value);
            var r = child_process_1.spawnSync("node", args, { cwd: path.join(__dirname, "../bin") });
            if (r.error) {
                throw r.error;
            }
            if (r.status > 0) {
                throw new Error(r.stderr.toString());
            }
            return r.stdout.toString().split(/\n|\r|\r\n/)[0];
        };
        return DecryptSync;
    }());
    KmsConfig.DecryptSync = DecryptSync;
    function decryptConfig(rawConf) {
        return __awaiter(this, void 0, void 0, function () {
            function decryptEachAttrs(obj) {
                return __awaiter(this, void 0, void 0, function () {
                    var promises, decryptedValues;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                promises = Object.keys(obj).map(function (k) {
                                    var v = obj[k];
                                    if (typeof v === "object") {
                                        if (v instanceof Encrypted) {
                                            return cipher.decrypt(v.value);
                                        }
                                        else {
                                            return decryptEachAttrs(v);
                                        }
                                    }
                                    else {
                                        return Promise.resolve(v);
                                    }
                                });
                                return [4 /*yield*/, Promise.all(promises)];
                            case 1:
                                decryptedValues = _a.sent();
                                Object.keys(obj).forEach(function (k, i) {
                                    obj[k] = decryptedValues[i];
                                });
                                return [2 /*return*/, obj];
                        }
                    });
                });
            }
            var vaultConfig, cipher;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        vaultConfig = rawConf["kms-vault"];
                        if (!vaultConfig) {
                            throw new Error("\"kms-vault\" is required in your config file.");
                        }
                        cipher = new cipher_1.Cipher.Cipher(vaultConfig);
                        return [4 /*yield*/, decryptEachAttrs(rawConf)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    }
    KmsConfig.decryptConfig = decryptConfig;
})(KmsConfig = exports.KmsConfig || (exports.KmsConfig = {}));
